#!/usr/bin/perl
#  Sorry, I didn't use strict.  But I have done some memory clean-up.
#  Shadow is 1 for you use a shadow passwd file, and 0 for not.
$shadow  = 1;
#  If you want the output to go to mail (address is defined below).
$mail    = 1;

#  The Location of your password files.
$passwd  = "/etc/passwd";
$spasswd = "/etc/shadow";
$debug   = 1;

#  The three database files Thor Creates.
$pwdDB   = "/var/log/thorpwd";
$sugidDB = "/var/log/thorsugid";
$csumDB  = "/var/log/thorcsum";
$cronDB  = "/var/log/thorcron";
$miscDB  = "/var/log/thormisc";

#  A file that contains a list of known shells on your system.
$shells = "/etc/shells";

#  External programs this script uses.
#  A checksum program (md5sum) is the only one tested.
$csumprog = "/usr/bin/md5sum";
#  The program to filter mail through.
$mailprog = "/usr/sbin/sendmail";
#  The program to list cronjobs.
$crontab  = "/usr/bin/crontab";

#  An array of the directories to checksum and keep an eye on.  = )
@csumdirs = ("/etc", "/bin", "/sbin", "/usr/bin", "/usr/sbin", "/usr/local/bin", "/usr/local/sbin", "/lib", "/usr/lib");

#  E-Mail address that you want Thor to send output to.
$email = "foo\@bar.com";

#  Send all print statement to the mail program instead of STDOUT
if($mail == 1){
	open(MAIL, "|$mailprog $email");
	select(MAIL);
}
$| = 1;

foreach $arg(@ARGV){
	if($arg eq "-i"){
		$FirstTime = 1;
	}elsif($arg eq "-h"){
		$Help = 1;
	}elsif($arg eq "-r"){
		$Reset = 1;
	}
}

if((($FirstTime + $Help + $Reset) > 1) || $Help == 1){
	print "Usage:\nthor.pl\t(Normal)\nthor.pl -i\t(Initialize)\nthor.pl -r\t(Reset DB's)\nthor.pl -h\t(This Message)\n";
	exit;
}elsif($Reset == 1){
	$FirstTime = 1;
	print "-="x20, "\n";
		print "        Resetting Thor's Databases\n";
	print "-="x20, "\n";
	unlink("$sugidDB");
	unlink(("$pwdDB" . ".dir"));
	unlink(("$pwdDB" . ".pag"));
	unlink(("$csumDB" . ".dir"));
	unlink(("$csumDB" . ".pag"));
	unlink(("$cronDB" . ".dir"));
	unlink(("$cronDB" . ".pag"));
	unlink(("$sugidDB" . ".dir"));
	unlink(("$sugidDB" . ".pag"));
	unlink(("$miscDB" . ".dir"));
	unlink(("$miscDB" . ".pag"));
}

&VerifyPrograms;
&InputPasswdInfo;
&DispRootAcct;
&UpdatePwdDB;
&CheckRUCrontab;
&UpdateCronDB;
&SurveyFiles;
&UpdateSUGIDDB;
&GetChecksums;
&UpdateChecksumDB;
if($FirstTime == 1){
	print "Remeber to run Thor without any arguments from now on.\n";
}

sub VerifyPrograms{
	print "-="x20, "\n";
		print "     Verifying the stability of Thor\n";
	print "-="x20, "\n";
	if((-l ($miscDB . ".dir")) || (-l ($miscDB . ".pag"))){
		die("$miscDB files exist as a link, and could be harmful if written to.");
	}
	if((-l ($pwdDB . ".dir")) || (-l ($pwdDB . ".pag"))){
		die("$pwdDB files exist as a link, and could be harmful if written to.");
	}
	if((-l ($sugidDB . ".dir")) || (-l ($sugidDB . ".pag"))){
		die("$sugidDB files exist as a link, and could be harmful if written to.");
	}
	if((-l ($csumDB . ".dir")) || (-l ($csumDB . ".pag"))){
		die("$csumDB files exist as a link, and could be harmful if written to.");
	}
	if((-l ($cronDB . ".dir")) || (-l ($cronDB . ".pag"))){
		die("$cronDB files exist as a link, and could be harmful if written to.");
	}
	dbmopen(%dbmisc, $miscDB, 0600) || die "Opening $miscDB\: $!\n";
	@dbcsumsize = split(":", $dbmisc{$csumprog});
	eval("\$csumsize = (-s \$csumprog)");
	print $csumsize;
	if($dbcsumsize[1] != $csumsize){
		if($FirstTime == 1){
			print "Updating: $csumprog\n";
			$csumcsum = `$csumprog $csumprog`;
			chomp($csumcsum);
			$csumcsum =~ s/\W.*//;
			$dbmisc{$csumprog} = join(":", $csumcsum, $csumsize);
		}else{
			die("$csumprog\'s file size has changed.  It's Possible this program has been tampered with.");
		}
		
	}
	$mailcsum = `$csumprog $mailprog`;
	chomp($mailcsum);
	$mailcsum =~ s/\W.*//;
	eval("\$mailsize = (-s \$mailprog)");
	$mailcheck = join(":", $mailcsum, $mailsize);
	if($mailcheck != $dbmisc{$mailprog}){
		if($FirstTime == 1){
			print "Updating: $mailprog\n";
			$dbmisc{$mailprog} = $mailcheck;
		}else{
			die("$mailprog\'s file info has changed.  It's Possible this program has been tampered with.");
		}
	}
	$croncsum = `$csumprog $crontab`;
	chomp($croncsum);
	$croncsum =~ s/\W.*//;
	eval("\$cronsize = (-s \$crontab)");
	$croncheck = join(":", $croncsum, $cronsize);
	if($croncheck != $dbmisc{$crontab}){
		if($FirstTime == 1){
			print "Updating: $crontab\n";
			$dbmisc{$crontab} = $croncheck;
		}else{
			die("$crontab\'s file info has changed.  It's Possible this program has been tampered with.");
		}
	}
	dbmclose(%dbmisc);
}

sub InputPasswdInfo{
	open(PASSWD, $passwd) || die "Opening $passwd\: $!\n";
	while(<PASSWD>){
		@data = split(":", $_);
		if(($data[2] == 0 || $data[3] == 0) || ($data[2] == 131072 || $data[3] == 131072)){
			chomp($_);
			@data = split(":", $_);
			$login = $data[0];
			$rnpwd{$login} = $data;
			if($shadow == 1){
				open(SHADOW, $spasswd) || die "Opening $spasswd\: $!\n";
				while(<SHADOW>){
					if(/$login/){
						chomp($_);
						@sdata = split(":", $_);
						$spwd = $sdata[1];
						$data[1] = $sdata[1];
					}
				}
				close(SHADOW);
			}
		$rnpwd{$login} = join(":", @data);
		}
	}
	close(PASSWD);
}

sub DispRootAcct{
		print "-="x20, "\n";
		print "     Users with root UID's and GID's\n";
		print "-="x20, "\n";
	foreach(keys %rnpwd){
		$login = $_;
		@data = split(":", $rnpwd{$login});
		$ruid = $data[2];
		$rgid = $data[3];
		$rhdir = $data[5];
		$rshl = $data[6];
		print "User Name: $login\nUID=$ruid\tGID=$rgid\tHome Dir=$rhdir\tSHELL=$rshl\n";
	}
	undef $login;
	undef @data;
	undef $ruid;
	undef $rgid;
	undef $rhdir;
	undef $rshl;
}

sub UpdatePwdDB{
	print "-="x20, "\n";
	print "   Updating Thor's Password Data Base\n";
	print "-="x20, "\n";
	dbmopen(%dbpwd, $pwdDB, 0600) || die "Opening $pwdDB\: $!\n";
	foreach $login(keys %rnpwd){
		if(! $dbpwd{$login}){
			print "$login\:\tAccount was not in the DataBase. [Adding...]\n";
			$dbpwd{$login} = $rnpwd{$login};
		}elsif($rnpwd{$login} ne $dbpwd{$login}){
			print "$login\:\tAccount information was changed.\n";
			@olddata = split(":", $rnpwd{$login});
			@dbdata = split(":", $dbpwd{$login});
			print "[Old Info]\tUID=$dbdata[2]\tGID=$dbdata[3]\tHome Dir=$dbdata[5]\tShell=$dbdata[6]\n";
			print "[Old Info]\tPasswd=$dbdata[1]\tPersonal Info=$dbdata[4]\n";
			print "[New Info]\tUID=$olddata[2]\tGID=$olddata[3]\tHome Dir=$olddata[5]\tShell=$olddata[6]\n";
			print "[New Info]\tPasswd=$olddata[1]\tPersonal Info=$olddata[4]\n";
			$dbpwd{$login} = $rnpwd{$login};
		}
	}
	foreach $login(keys %dbpwd){
		if(! $rnpwd{$login}){
			print "$login\:\tAccount was not found. [Removing...]\n";
			delete($dbpwd{$login});
		}
	}
	dbmclose(%dbpwd);
	undef %dbpwd;
	undef @olddata;
	undef @dbdata;
	undef $login;
}

sub SurveyFiles{
	print "-="x20, "\n";
	print "      Gathering [U/G]ID Information\n";
	print "-="x20, "\n";
	$dlist[0] = "";
	foreach $dir (@dlist){
		foreach $file (<$dir/*>){
			$file =~ s/(\W)/\\\1/g;
			$file =~ s/\\\//\//g;
			$file =~ s/\\\./\./g;
			$file =~ s/\\\-/\-/g;
			$file =~ s/\\\+/\+/g;
			if ((-d $file) && ($file ne "/dev") && ($file ne "/proc") && (! -l $file)){
				push(@dlist, $file);
			}elsif (((-u $file) || (-g $file)) && (! -l $file)){
				&CheckSetUGID;
			}
		}
		foreach $file (<$dir/.*>){
			$file =~ s/(\W)/\\\1/g;
			$file =~ s/\\\//\//g;
			$file =~ s/\\\./\./g;
			$file =~ s/\\\-/\-/g;
			$file =~ s/\\\+/\+/g;
			if ((-d $file) && (! -l $file) && (! (($file =~ /\/\.$/) || ($file =~ /\/\.\.$/)))){
				push(@dlist, $file);
			}elsif (((-u $file) || (-g $file)) && ((! -l $file) && (! (($file =~ /\/\.$/) || ($file =~ /\/\.\.$/))))){
				&CheckSetUGID;
			}
		}

	}
	undef @dlist;
	undef $file;
	undef $dir;
}

sub CheckSetUGID{
	if(-u $file || -g $file){
		@info = stat($file);
		eval("\$size = (-s \$file)");
		if ($info[4] == 0 || $info[5] == 0){
			$nuglist{$file} = "$info[4]\:$info[5]\:$size";
		}
	}
	undef @info;
}

sub UpdateSUGIDDB{
	print "-="x20, "\n";
	print "  Updating Thor's Set [U/G]ID DataBase\n";
	print "-="x20, "\n";
	dbmopen(%dbsugid, $sugidDB, 0600) || die "Opening $sugidDB\: $!\n";
	foreach $file(sort keys %nuglist){
		if(! $dbsugid{$file}){
			print "$file\:\tFile was not in the DataBase. [Adding...]\n";
			$dbsugid{$file} = $nuglist{$file};
			&ShellChecksum;
		}elsif($dbsugid{$file} ne $nuglist{$file}){
			print "$file\:\tFile information was changed.\n";
			@oldugid = split(":", $dbsugid{$file});
			@newugid = split(":", $nuglist{$file});
			print "[Old Info]\tUID=$oldguid[0]\tGID=$oldugid[1]\tFile Size=$oldugid[2]\n"; 
			print "[New Info]\tUID=$newugid[0]\tGID=$newugid[1]\tFile Size=$newugid[2]\n"; 
			$dbsugid{$file} = $nuglist{$file};
		}
	}

	foreach $file(sort keys %dbsugid){
		if(! $nuglist{$file}){
			print "$file\:\tFile was not found. [Removing...]\n";
			delete($dbsugid{$file});
		}
	}
	dbmclose(%dbsugid);
	undef %dbsugid;
	undef %nuglist;
	undef $file;
}

sub ShellChecksum{
	open(CSUM, $shells);
	while(<CSUM>){
		chomp($_);
		if(! -l $_){
			$scsum{$_} = `$csumprog $_`;
			$scsum{$_} =~ s/\W.*//;
		}
	}
	close(CSUM);
	$fcsum = `$csumprog $file`;
	$fcsum =~ s/\W.*//;
	foreach $shl(sort keys %scsum){
		if($fcsum eq $scsum{$shl}){
			print "Warning:\t$file has the same checksum as $shl\!\n";
		}
	}
	undef %scsum;
	undef %fcsum;
	undef $shells;
	undef $shl;
}

sub GetChecksums{
	print "-="x20, "\n";
	print "      Gathering Checksum Information\n";
	print "-="x20, "\n";
	foreach $csdir(@csumdirs){
		@dlist[0] = $csdir;
		foreach $dir (@dlist){
			foreach $file (<$dir/*>){
				$file =~ s/(\W)/\\\1/g;
				$file =~ s/\\\//\//g;
				$file =~ s/\\\./\./g;
				$file =~ s/\\\-/\-/g;
				$file =~ s/\\\+/\+/g;
				if ((-d $file) && (! -l $file)){
					push(@dlist, $file);
				}elsif (! -l $file){
					&AddToChecksumList;
				}
			}
			foreach $file (<$dir/.*>){
				$file =~ s/(\W)/\\\1/g;
				$file =~ s/\\\//\//g;
				$file =~ s/\\\./\./g;
				$file =~ s/\\\-/\-/g;
				$file =~ s/\\\+/\+/g;
				if ((-d $file) && (! -l $file) && (! (($file =~ /\/\.$/) || ($file =~ /\/\.\.$/)))){
					push(@dlist, $file);
				}elsif ((! -l $file) && (! (($file =~ /\/\.$/) || ($file =~ /\/\.\.$/)))){
					&AddToChecksumList;
				}
			}
		}
		splice(@dlist, 0);
	}
	undef @dlist;
	undef $file;
	undef $csdir;
}

sub AddToChecksumList{
	$ncsumlist{$file} = `$csumprog $file`;
	chomp($ncsumlist{$file});
	$ncsumlist{$file} =~ s/\W.*//;
	eval("\$ncsumlist{\$file} = \$ncsumlist{\$file} . ':' . (-s \$file)");
}

sub UpdateChecksumDB{
	print "-="x20, "\n";
	print "    Updating Thor's Checksum DataBase\n";
	print "-="x20, "\n";
	dbmopen(%dbcsumlist, $csumDB, 0600) || die "Opening $csumDB\: $!\n";
	foreach $file(sort keys %ncsumlist){
		if(! $dbcsumlist{$file}){
			print "$file\:\tFile was not in the DataBase. [Adding...]\n";
			$dbcsumlist{$file} = $ncsumlist{$file};
		}elsif($dbcsumlist{$file} ne $ncsumlist{$file}){
			print "$file\:\tFile checksum has changed.\n";
			@olddata = split(":", $ncsumlist{$file});
			@dbdata = split(":", $dbcsumlist{$file});
			print "[Old Info]\nChecksum=$dbdata[0]\tFile Size=$dbdata[1]\n";
			print "[New Info]\nChecksum=$olddata[0]\tFile Size=$olddata[1]\n";
			$dbcsumlist{$file} = $ncsumlist{$file};
		}
	}
	foreach $file(sort keys %dbcsumlist){
		if(! $ncsumlist{$file}){
			print "$file\:\tFile was not found. [Removing...]\n";
			delete($dbcsumlist{$file});
		}
	}
	dbmclose(%dbcsumlist);
	undef %dbcsumlist;
	undef %ncsumlist;
	undef @olddata;
	undef @dbdata;
	undef $file;
}

sub CheckRUCrontab{
	print "-="x20, "\n";
	print "   Gathering Root Users Crontab Lists\n";
	print "-="x20, "\n";
	foreach $login(keys %rnpwd){
		open(CRON, "$crontab -u $login -l |");
		while(<CRON>){
			if (! ($_ =~ /^#/)){
				$cronlist{$login} = $cronlist{$login} . $_;
			}
		}
		close(CRON);
	}
	undef $login;
	undef %rnpwd;
}

sub UpdateCronDB{
	print "-="x20, "\n";
	print "    Updating Thor's Crontab DataBase\n";
	print "-="x20, "\n";
	dbmopen(%dbcronlist, $cronDB, 0600) || die "Opening $cronDB\: $!\n";
	foreach $login(sort keys %cronlist){
		if(! $dbcronlist{$login}){
			print "$login\:\tAccount was not in the DataBase. [Adding...]\n";
			$dbcronlist{$login} = $cronlist{$login};
		}elsif($dbcronlist{$login} ne $cronlist{$login}){
			print "$login\:\tCrontab has changed.\n";
			print "[Old Crontab]\n$dbcronlist{$login}";
			print "[New Crontab]\n$cronlist{$login}";
			$dbcronlist{$login} = $cronlist{$login};
		}
	}
	foreach $login(sort keys %dbcronlist){
		if(! $cronlist{$login}){
			print "$login\:\tAccount was not found. [Removing...]\n";
			delete($dbcronlist{$login});
		}
	}
	dbmclose(%dbcronlist);
	undef %dbcronlist;
	undef %cronlist;
	undef $login;
}

sub Debug(){
	if ($debug == 1){
		print @_;
		print "\n";
	}
}
